/***********************************************************************
 *
 *  CHIPS.C -  identify CPU type and NDP type
 *
 *  Modified from TEST.C (Pat Shea) to work with TEENY startup code
 *  generate an executable file 10 times smaller, and add returning
 *  the types as the DOS error level for use in a batch file.
 *
 *  David Gwillim  16 June 1990
 *
 **********************************************************************/

int fputsh(char *str,int handle);           /* FPUTSH.ASM */
void exit(char code);                       /* EXIT.C     */
int chips(void);                            /* CHIPSTC.C  */

#define STDOUT 1

void main()
{

    int i = chips();   /* get the int return that tells the CPU and
                            NDP (math coprocessor) types              */

/***********************************************************************
 * This first switch gives us the high order digits off the return from
 * chips() and determines the CPU type.
 **********************************************************************/

    fputsh("\r\nCPU is ",STDOUT);

    switch(i / 10)
    {
        case  8:
            fputsh("8088/8086",STDOUT);
            break;
        case 18:
            fputsh("80188/80186",STDOUT);
            break;
        case 20:
            fputsh("NEC V20/V30",STDOUT);
            break;
        case 28:
            fputsh("80286",STDOUT);
            break;
        case 38:
            fputsh("80386",STDOUT);
            break;
        default:
            fputsh("DUNNO!",STDOUT);
            exit(99);
    }

/**********************************************************************
 * Determine the NDP by stripping off all the high end digits
 * leaving us with just the low order with the NDP info.....
 **********************************************************************/

    fputsh(", NDP is ",STDOUT);

    switch(i % 10)
    {
        case 0:
            fputsh("NONE",STDOUT);
            break;
        case 1:
            fputsh("8087",STDOUT);
            break;
        case 2:
            fputsh("80287",STDOUT);
            break;
        case 3:
            fputsh("80387",STDOUT);
            break;
        default:
            fputsh("DUNNO!!",STDOUT);
            exit(99);
    }

    fputsh("\r\n",STDOUT);
    /* return the CPU and NDP types as the error level */
    exit(i);
}
